# Generated by Django 5.2 on 2025-04-14 16:41

from django.db import migrations, models

import aurora.i18n.fields


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Message",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("timestamp", models.DateTimeField(auto_now_add=True)),
                (
                    "locale",
                    aurora.i18n.fields.LanguageField(
                        choices=[
                            ("en-us", "English | English"),
                            ("ar-ae", " | عربيArabic"),
                            ("cs-cz", "čeština | Czech"),
                            ("de-de", "Deutsch | German"),
                            ("es-es", "Español | Spanish"),
                            ("fr-fr", "Français | French"),
                            ("hu-hu", "Magyar | Hungarian"),
                            ("it-it", "Italiano | Italian"),
                            ("pl-pl", "Polskie | Polish"),
                            ("pt-pt", "Português | Portuguese"),
                            ("ro-ro", "Română | Romanian"),
                            ("ru-ru", "Русский | Russian"),
                            ("si-si", "සිංහල | Sinhala"),
                            ("ta-ta", "தமிழ் | Tamil"),
                            ("uk-ua", "український | Ukrainian"),
                            ("hi-hi", "हिंदी | Hindi"),
                        ],
                        db_index=True,
                        default="en-us",
                        help_text="The locale of the message.",
                        max_length=10,
                        null=True,
                        verbose_name="Language",
                    ),
                ),
                ("msgid", models.TextField(db_index=True, help_text="Original message value")),
                ("msgstr", models.TextField(blank=True, help_text="Localized Message content.", null=True)),
                (
                    "md5",
                    models.CharField(
                        help_text="Localised code of the message", max_length=512, unique=True, verbose_name="MD5"
                    ),
                ),
                (
                    "msgcode",
                    models.CharField(
                        help_text="Code of the message. It is shared between translations of same message.",
                        max_length=512,
                        verbose_name="Code",
                    ),
                ),
                ("auto", models.BooleanField(default=False, help_text="Is this message auto-generated?")),
                (
                    "draft",
                    models.BooleanField(default=True, help_text="If draft the message is not used in translation"),
                ),
                ("used", models.BooleanField(default=True, help_text="Is this message used somewhere in Aurora?")),
                (
                    "last_hit",
                    models.DateTimeField(
                        blank=True, help_text="Last time this translation hase been used message", null=True
                    ),
                ),
            ],
            options={
                "unique_together": {("msgid", "locale")},
            },
        ),
    ]
