# Generated by Django 5.2 on 2025-04-14 16:42

import concurrency.fields
import django.utils.timezone
import strategy_field.fields
from django.db import migrations, models

import aurora.i18n.models
import aurora.registration.fields
import aurora.registration.models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Record",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("unique_field", models.CharField(blank=True, db_index=True, max_length=255, null=True)),
                ("remote_ip", aurora.registration.models.RemoteIp(blank=True, null=True)),
                ("timestamp", models.DateTimeField(auto_now_add=True, db_index=True)),
                ("storage", models.BinaryField(blank=True, null=True)),
                ("ignored", models.BooleanField(blank=True, default=False, null=True)),
                ("size", models.IntegerField(blank=True, null=True)),
                ("counters", models.JSONField(blank=True, null=True)),
                ("fields", models.JSONField(blank=True, null=True)),
                ("files", models.BinaryField(blank=True, null=True)),
                ("index1", models.CharField(blank=True, max_length=255, null=True)),
                ("index2", models.CharField(blank=True, max_length=255, null=True)),
                ("index3", models.CharField(blank=True, max_length=255, null=True)),
                ("is_offline", models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name="Registration",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("version", concurrency.fields.AutoIncVersionField(default=0, help_text="record revision number")),
                ("last_update_date", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=255)),
                ("title", models.CharField(blank=True, max_length=500, null=True)),
                ("slug", models.SlugField(blank=True, max_length=500, null=True, unique=True)),
                ("start", models.DateField(default=django.utils.timezone.now)),
                ("end", models.DateField(blank=True, null=True)),
                ("active", models.BooleanField(default=False)),
                (
                    "archived",
                    models.BooleanField(
                        default=False, help_text="Archived/Terminated registration cannot be activated/reopened"
                    ),
                ),
                (
                    "locale",
                    models.CharField(
                        choices=[
                            ("en-us", "English | English"),
                            ("ar-ae", " | عربيArabic"),
                            ("cs-cz", "čeština | Czech"),
                            ("de-de", "Deutsch | German"),
                            ("es-es", "Español | Spanish"),
                            ("fr-fr", "Français | French"),
                            ("hu-hu", "Magyar | Hungarian"),
                            ("it-it", "Italiano | Italian"),
                            ("pl-pl", "Polskie | Polish"),
                            ("pt-pt", "Português | Portuguese"),
                            ("ro-ro", "Română | Romanian"),
                            ("ru-ru", "Русский | Russian"),
                            ("si-si", "සිංහල | Sinhala"),
                            ("ta-ta", "தமிழ் | Tamil"),
                            ("uk-ua", "український | Ukrainian"),
                            ("hi-hi", "हिंदी | Hindi"),
                        ],
                        default="en-us",
                        max_length=10,
                        verbose_name="Default locale",
                    ),
                ),
                ("dry_run", models.BooleanField(default=False)),
                ("handler", strategy_field.fields.StrategyField(blank=True, default=None, null=True)),
                ("show_in_homepage", models.BooleanField(default=False)),
                (
                    "locales",
                    aurora.registration.fields.ChoiceArrayField(
                        base_field=models.CharField(
                            choices=[
                                ("en-us", "English | English"),
                                ("ar-ae", " | عربيArabic"),
                                ("cs-cz", "čeština | Czech"),
                                ("de-de", "Deutsch | German"),
                                ("es-es", "Español | Spanish"),
                                ("fr-fr", "Français | French"),
                                ("hu-hu", "Magyar | Hungarian"),
                                ("it-it", "Italiano | Italian"),
                                ("pl-pl", "Polskie | Polish"),
                                ("pt-pt", "Português | Portuguese"),
                                ("ro-ro", "Română | Romanian"),
                                ("ru-ru", "Русский | Russian"),
                                ("si-si", "සිංහල | Sinhala"),
                                ("ta-ta", "தமிழ் | Tamil"),
                                ("uk-ua", "український | Ukrainian"),
                                ("hi-hi", "हिंदी | Hindi"),
                            ],
                            max_length=10,
                        ),
                        blank=True,
                        null=True,
                        size=None,
                    ),
                ),
                ("intro", models.TextField(blank=True, default="", null=True)),
                ("footer", models.TextField(blank=True, default="", null=True)),
                ("client_validation", models.BooleanField(blank=True, default=False)),
                (
                    "unique_field_path",
                    models.CharField(
                        blank=True, help_text="JMESPath expression to retrieve unique field", max_length=1000, null=True
                    ),
                ),
                (
                    "unique_field_error",
                    models.CharField(
                        blank=True,
                        help_text="Error message in case of duplicate 'unique_field'",
                        max_length=255,
                        null=True,
                    ),
                ),
                ("public_key", models.TextField(blank=True, null=True)),
                ("encrypt_data", models.BooleanField(default=False)),
                ("advanced", models.JSONField(blank=True, default=dict)),
                (
                    "protected",
                    models.BooleanField(
                        default=False,
                        help_text="If true, limit access to users with 'registration.register' permission",
                    ),
                ),
                ("is_pwa_enabled", models.BooleanField(default=False)),
                ("export_allowed", models.BooleanField(default=False)),
            ],
            options={
                "ordering": ("name", "title"),
                "permissions": (
                    ("can_manage_registration", "Can manage Registration"),
                    ("register", "Can use Registration"),
                    ("create_translation", "Can Create Translation"),
                    ("export_data", "Can Export Data"),
                    ("can_view_data", "Can View Collected data"),
                ),
                "get_latest_by": "start",
            },
            bases=(aurora.i18n.models.I18NModel, models.Model),
        ),
    ]
